From c30f15e9c542e0061e1f24505399bd0392a45481 Mon Sep 17 00:00:00 2001
From: Vijay Kiran Kamuju <infyquest@gmail.com>
Date: Tue, 16 Jan 2018 13:08:26 +0100
Subject: [PATCH 3/3] [ole2disp.dll16] add SafeArrayDestroyData implementation

This helps bug #9805

Signed-off-by: Vijay Kiran Kamuju <infyquest@gmail.com>
---
 dlls/ole2disp.dll16/ole2disp.c          | 17 +++++++++++++++++
 dlls/ole2disp.dll16/ole2disp.dll16.spec |  2 +-
 2 files changed, 18 insertions(+), 1 deletion(-)

diff --git a/dlls/ole2disp.dll16/ole2disp.c b/dlls/ole2disp.dll16/ole2disp.c
index d61b5e8c5a11..9340dabc3ce7 100644
--- a/dlls/ole2disp.dll16/ole2disp.c
+++ b/dlls/ole2disp.dll16/ole2disp.c
@@ -234,6 +234,23 @@ HRESULT WINAPI SafeArrayDestroyDescriptor16(SEGPTR s)
     return S_OK;
 }
 
+/******************************************************************************
+ *    SafeArrayDestroyData [OLE2DISP.41]
+ */
+HRESULT WINAPI SafeArrayDestroyData16(SAFEARRAY16 *sa)
+{
+    TRACE("%p\n", sa);
+
+    if (!sa)
+        return E_INVALIDARG16;
+
+    if (sa->cLocks)
+        return DISP_E_ARRAYISLOCKED;
+
+    safearray_free(sa->pvData);
+    return S_OK;
+}
+
 /* This implementation of the BSTR API is 16-bit only. It
    represents BSTR as a 16:16 far pointer, and the strings
    as ISO-8859 */
diff --git a/dlls/ole2disp.dll16/ole2disp.dll16.spec b/dlls/ole2disp.dll16/ole2disp.dll16.spec
index 4b8af41172aa..a79887024a57 100644
--- a/dlls/ole2disp.dll16/ole2disp.dll16.spec
+++ b/dlls/ole2disp.dll16/ole2disp.dll16.spec
@@ -38,7 +38,7 @@
 38 pascal SafeArrayAllocDescriptor(word ptr) SafeArrayAllocDescriptor16
 39 pascal SafeArrayAllocData(ptr) SafeArrayAllocData16
 40 pascal SafeArrayDestroyDescriptor(segptr) SafeArrayDestroyDescriptor16
-41 stub SAFEARRAYDESTROYDATA
+41 pascal SafeArrayDestroyData(ptr) SafeArrayDestroyData16
 42 stub SAFEARRAYREDIM
 43 stub VARI2FROMI4
 44 stub VARI2FROMR4
-- 
2.15.1

